diff -uNr blt2.4z.orig/src/bltColor.c blt2.4z/src/bltColor.c
--- blt2.4z.orig/src/bltColor.c	2002-08-09 21:29:33.000000000 -0400
+++ blt2.4z/src/bltColor.c	2013-07-15 11:15:51.000000000 -0400
@@ -535,15 +535,15 @@
     for (i = 0; i < nPixels; i++, pixelPtr++) {
 	color.value = pixelPtr->value;
 	color.Alpha = 0xFF;	/* Ignore alpha-channel values */
-	hPtr = Blt_CreateHashEntry(&colorTable, (char *)color.value, &isNew);
+	hPtr = Blt_CreateHashEntry(&colorTable, (char *)(uintptr_t)color.value, &isNew);
 	if (isNew) {
 	    refCount = 1;
 	    nColors++;
 	} else {
-	    refCount = (int)Blt_GetHashValue(hPtr);
+	    refCount = (int)(uintptr_t)Blt_GetHashValue(hPtr);
 	    refCount++;
 	}
-	Blt_SetHashValue(hPtr, (ClientData)refCount);
+	Blt_SetHashValue(hPtr, (ClientData)(uintptr_t)refCount);
     }
     Blt_DeleteHashTable(&colorTable);
     return nColors;
diff -uNr blt2.4z.orig/src/bltConfig.c blt2.4z/src/bltConfig.c
--- blt2.4z.orig/src/bltConfig.c	2002-09-18 18:30:51.000000000 -0400
+++ blt2.4z/src/bltConfig.c	2013-07-15 11:15:51.000000000 -0400
@@ -275,7 +275,7 @@
     char *widgRec;		/* Cubicle structure record */
     int offset;			/* Offset of style in record */
 {
-    unsigned int mask = (unsigned int)clientData;	/* Bit to be tested */
+    unsigned int mask = (unsigned int)(uintptr_t)clientData;	/* Bit to be tested */
     int *flagPtr = (int *)(widgRec + offset);
     int bool;
 
@@ -311,7 +311,7 @@
     int offset;			/* Offset of fill in widget record */
     Tcl_FreeProc **freeProcPtr;	/* Not Used. */
 {
-    unsigned int mask = (unsigned int)clientData;	/* Bit to be tested */
+    unsigned int mask = (unsigned int)(uintptr_t)clientData;	/* Bit to be tested */
     unsigned int bool = *(unsigned int *)(widgRec + offset);
 
     return (bool & mask) ? "1" : "0";
@@ -392,7 +392,7 @@
     int offset;			/* Offset of pixel size in record */
 {
     int *valuePtr = (int *)(widgRec + offset);
-    return Blt_GetPixels(interp, tkwin, string, (int)clientData, valuePtr);
+    return Blt_GetPixels(interp, tkwin, string, (int)(uintptr_t)clientData, valuePtr);
 }
 
 /*
@@ -481,7 +481,7 @@
     int offset;			/* Offset of pixel size in record */
 {
     int *valuePtr = (int *)(widgRec + offset);
-    return Blt_GetInt(interp, string, (int)clientData, valuePtr);
+    return Blt_GetInt(interp, string, (int)(uintptr_t)clientData, valuePtr);
 }
 
 /*
@@ -1206,6 +1206,65 @@
 }
 
 /*
+ * Tk_ConfigureWidget nolonger sets the TK_CONFIG_OPTION_SPECIFIED bit.
+ * Rather than convert all the BLT widgets to Tk_SetOptions,
+ * Blt_ConfigureWidget will serve as a wrapper for Tk_ConfigureWidget.
+ */
+int
+Blt_ConfigureWidget(interp, tkwin, specs, argc, argv, widgRec, flags)
+    Tcl_Interp *interp;
+    Tk_Window tkwin;		/* Window to associate with component */
+    Tk_ConfigSpec *specs;
+    int argc;
+    char **argv;
+    char *widgRec;
+    int flags;
+{
+  int i, nspec;
+  char *value;
+  char **valuesIn;
+  Tk_ConfigSpec *specPtr;
+
+  /* before configure get all the config values */
+  nspec = 0 ;
+  for (specPtr = specs; specPtr->type != TK_CONFIG_END; specPtr++) nspec++;
+  valuesIn = (char**) Tcl_Alloc(nspec*sizeof(char*));
+
+  for (i=0, specPtr = specs; specPtr->type != TK_CONFIG_END; specPtr++, i++) {
+    if (Tk_ConfigureValue(interp, tkwin, specs, widgRec,
+			  specPtr->argvName, 0) != TCL_OK) {
+      return TCL_ERROR;
+    }
+    value = Tcl_GetStringResult(interp);
+    valuesIn[i] = (char*) Tcl_Alloc((strlen(value)+1)*sizeof(char));
+    strcpy(valuesIn[i], value);
+  }
+  /* configure */
+  if (Tk_ConfigureWidget(interp, tkwin, specs, argc, argv, widgRec, flags) !=
+      TCL_OK ) { return TCL_ERROR; }
+  /*
+    read back the new values and compare with inputs
+    set the TK_CONFIG_OPTION_SPECIFIED if value changed
+    clear that bit if the value didnt change
+  */
+  for (i=0, specPtr = specs; specPtr->type != TK_CONFIG_END; specPtr++, i++) {
+    if (Tk_ConfigureValue(interp, tkwin, specs, widgRec,
+			  specPtr->argvName, 0) != TCL_OK) {
+      return TCL_ERROR;
+    }
+    value = Tcl_GetStringResult(interp);
+    if ( strcmp(value, valuesIn[i]) ) {
+      specPtr->specFlags |= TK_CONFIG_OPTION_SPECIFIED;
+    } else {
+      specPtr->specFlags &= ~TK_CONFIG_OPTION_SPECIFIED;
+    }
+    Tcl_Free((char*)valuesIn[i]);
+  }
+  Tcl_Free((char*)valuesIn);
+  return TCL_OK;
+}
+
+/*
  *----------------------------------------------------------------------
  *
  * Blt_ConfigureWidgetComponent --
@@ -1275,7 +1334,7 @@
     Blt_Free(tempName);
 
     Tk_SetClass(tkwin, className);
-    result = Tk_ConfigureWidget(interp, tkwin, specsPtr, argc, argv, widgRec,
+    result = Blt_ConfigureWidget(interp, tkwin, specsPtr, argc, argv, widgRec,
 	flags);
     if (isTemporary) {
 	Tk_DestroyWindow(tkwin);
diff -uNr blt2.4z.orig/src/bltContainer.c blt2.4z/src/bltContainer.c
--- blt2.4z.orig/src/bltContainer.c	2002-07-14 19:33:24.000000000 -0400
+++ blt2.4z/src/bltContainer.c	2013-07-15 11:15:51.000000000 -0400
@@ -389,7 +389,7 @@
     Tcl_Interp *interp;
     Container *cntrPtr;
 {
-    int x, y, width, height, borderWidth, depth;
+    int x= 0, y= 0, width, height, borderWidth, depth;
     int xOffset, yOffset;
     Window root, dummy;
     Tk_ErrorHandler handler;
@@ -822,7 +822,7 @@
     char *widgRec;		/* Widget record */
     int offset;			/* Offset to field in structure */
 {
-    unsigned int flags = (int)clientData;
+    unsigned int flags = (int)(uintptr_t)clientData;
     Container *cntrPtr = (Container *)widgRec;
     Window *winPtr = (Window *) (widgRec + offset);
     Tk_Window tkAdopted;
@@ -1169,7 +1169,7 @@
     GC newGC;
     int width, height;
 
-    if (Tk_ConfigureWidget(interp, cntrPtr->tkwin, configSpecs, argc, argv,
+    if (Blt_ConfigureWidget(interp, cntrPtr->tkwin, configSpecs, argc, argv,
 	    (char *)cntrPtr, flags) != TCL_OK) {
 	return TCL_ERROR;
     }
diff -uNr blt2.4z.orig/src/bltDragdrop.c blt2.4z/src/bltDragdrop.c
--- blt2.4z.orig/src/bltDragdrop.c	2002-07-18 02:35:32.000000000 -0400
+++ blt2.4z/src/bltDragdrop.c	2013-07-15 11:15:51.000000000 -0400
@@ -1065,7 +1065,7 @@
     Token *tokenPtr;
 
     tokenPtr = &(srcPtr->token);
-    if (Tk_ConfigureWidget(interp, srcPtr->tkwin, tokenConfigSpecs, argc, argv,
+    if (Blt_ConfigureWidget(interp, srcPtr->tkwin, tokenConfigSpecs, argc, argv,
 	    (char *)tokenPtr, TK_CONFIG_ARGV_ONLY) != TCL_OK) {
 	return TCL_ERROR;
     }
@@ -1293,7 +1293,7 @@
     /*
      *  Handle the bulk of the options...
      */
-    if (Tk_ConfigureWidget(interp, srcPtr->tkwin, configSpecs, argc, argv,
+    if (Blt_ConfigureWidget(interp, srcPtr->tkwin, configSpecs, argc, argv,
 	    (char *)srcPtr, flags) != TCL_OK) {
 	return TCL_ERROR;
     }
diff -uNr blt2.4z.orig/src/bltGrAxis.c blt2.4z/src/bltGrAxis.c
--- blt2.4z.orig/src/bltGrAxis.c	2002-09-18 18:30:51.000000000 -0400
+++ blt2.4z/src/bltGrAxis.c	2013-07-15 11:15:51.000000000 -0400
@@ -669,7 +669,7 @@
     char *widgRec;		/* Pointer to structure record. */
     int offset;			/* Offset of field in structure. */
 {
-    unsigned int mask = (unsigned int)clientData;
+    unsigned int mask = (unsigned int)(uintptr_t)clientData;
     Axis *axisPtr = (Axis *)widgRec;
     Ticks **ticksPtrPtr = (Ticks **) (widgRec + offset);
     int nTicks;
@@ -1268,39 +1268,39 @@
  * ----------------------------------------------------------------------
  */
 static double
-NiceNum(x, round)
+NiceNum(x, iround)
     double x;
-    int round;			/* If non-zero, round. Otherwise take ceiling
+    int iround;			/* If non-zero, round. Otherwise take ceiling
 				 * of value. */
 {
     double expt;		/* Exponent of x */
     double frac;		/* Fractional part of x */
-    double nice;		/* Nice, rounded fraction */
+    double dnice;		/* Nice, rounded fraction */
 
     expt = floor(log10(x));
     frac = x / EXP10(expt);	/* between 1 and 10 */
-    if (round) {
+    if (iround) {
 	if (frac < 1.5) {
-	    nice = 1.0;
+	    dnice = 1.0;
 	} else if (frac < 3.0) {
-	    nice = 2.0;
+	    dnice = 2.0;
 	} else if (frac < 7.0) {
-	    nice = 5.0;
+	    dnice = 5.0;
 	} else {
-	    nice = 10.0;
+	    dnice = 10.0;
 	}
     } else {
 	if (frac <= 1.0) {
-	    nice = 1.0;
+	    dnice = 1.0;
 	} else if (frac <= 2.0) {
-	    nice = 2.0;
+	    dnice = 2.0;
 	} else if (frac <= 5.0) {
-	    nice = 5.0;
+	    dnice = 5.0;
 	} else {
-	    nice = 10.0;
+	    dnice = 10.0;
 	}
     }
-    return nice * EXP10(expt);
+    return dnice * EXP10(expt);
 }
 
 static Ticks *
@@ -1420,63 +1420,66 @@
     double min, max;
 {
     double range;
-    double tickMin, tickMax;
+    double tickMin= 0, tickMax= 0;
     double majorStep, minorStep;
     int nMajor, nMinor;
 
-    min = (min != 0.0) ? log10(FABS(min)) : 0.0;
-    max = (max != 0.0) ? log10(FABS(max)) : 1.0;
-
-    tickMin = floor(min);
-    tickMax = ceil(max);
-    range = tickMax - tickMin;
-
-    if (range > 10) {
-	/* There are too many decades to display a major tick at every
-	 * decade.  Instead, treat the axis as a linear scale.  */
-	range = NiceNum(range, 0);
-	majorStep = NiceNum(range / DEF_NUM_TICKS, 1);
-	tickMin = UFLOOR(tickMin, majorStep);
-	tickMax = UCEIL(tickMax, majorStep);
-	nMajor = (int)((tickMax - tickMin) / majorStep) + 1;
-	minorStep = EXP10(floor(log10(majorStep)));
-	if (minorStep == majorStep) {
-	    nMinor = 4, minorStep = 0.2;
+    nMajor = nMinor = 0;
+    majorStep = minorStep = 0.0;
+    if (min < max) {
+	min = (min != 0.0) ? log10(FABS(min)) : 0.0;
+	max = (max != 0.0) ? log10(FABS(max)) : 1.0;
+	
+	tickMin = floor(min);
+	tickMax = ceil(max);
+	range = tickMax - tickMin;
+	
+	if (range > 10) {
+	    /* There are too many decades to display a major tick at every
+	     * decade.  Instead, treat the axis as a linear scale.  */
+	    range = NiceNum(range, 0);
+	    majorStep = NiceNum(range / DEF_NUM_TICKS, 1);
+	    tickMin = UFLOOR(tickMin, majorStep);
+	    tickMax = UCEIL(tickMax, majorStep);
+	    nMajor = (int)((tickMax - tickMin) / majorStep) + 1;
+	    minorStep = EXP10(floor(log10(majorStep)));
+	    if (minorStep == majorStep) {
+		nMinor = 4, minorStep = 0.2;
+	    } else {
+		nMinor = Round(majorStep / minorStep) - 1;
+	    }
 	} else {
-	    nMinor = Round(majorStep / minorStep) - 1;
-	}
-    } else {
-	if (tickMin == tickMax) {
-	    tickMax++;
-	}
-	majorStep = 1.0;
-	nMajor = (int)(tickMax - tickMin + 1); /* FIXME: Check this. */
-
-	minorStep = 0.0;	/* This is a special hack to pass
+	    if (tickMin == tickMax) {
+		tickMax++;
+	    }
+	    majorStep = 1.0;
+	    nMajor = (int)(tickMax - tickMin + 1); /* FIXME: Check this. */
+	    
+	    minorStep = 0.0;	/* This is a special hack to pass
 				 * information to the GenerateTicks
 				 * routine. An interval of 0.0 tells
 				 *	1) this is a minor sweep and 
 				 *	2) the axis is log scale.  
 				 */
-	nMinor = 10;
-    }
-    if ((axisPtr->looseMin == TICK_RANGE_TIGHT) ||
-	((axisPtr->looseMin == TICK_RANGE_LOOSE) && 
-	 (DEFINED(axisPtr->reqMin)))) {
-	tickMin = min;
-	nMajor++;
-    }
-    if ((axisPtr->looseMax == TICK_RANGE_TIGHT) ||
-	((axisPtr->looseMax == TICK_RANGE_LOOSE) &&
-	 (DEFINED(axisPtr->reqMax)))) {
-	tickMax = max;
+	    nMinor = 10;
+	}
+	if ((axisPtr->looseMin == TICK_RANGE_TIGHT) ||
+	    ((axisPtr->looseMin == TICK_RANGE_LOOSE) && 
+	     (DEFINED(axisPtr->reqMin)))) {
+	    tickMin = min;
+	    nMajor++;
+	}
+	if ((axisPtr->looseMax == TICK_RANGE_TIGHT) ||
+	    ((axisPtr->looseMax == TICK_RANGE_LOOSE) &&
+	     (DEFINED(axisPtr->reqMax)))) {
+	    tickMax = max;
+	}
     }
     axisPtr->majorSweep.step = majorStep;
     axisPtr->majorSweep.initial = floor(tickMin);
     axisPtr->majorSweep.nSteps = nMajor;
     axisPtr->minorSweep.initial = axisPtr->minorSweep.step = minorStep;
     axisPtr->minorSweep.nSteps = nMinor;
-
     SetAxisRange(&axisPtr->axisRange, tickMin, tickMax);
 }
 
@@ -1546,36 +1549,40 @@
     Axis *axisPtr;
     double min, max;
 {
-    double range, step;
+    double range, step= 0;
     double tickMin, tickMax;
     double axisMin, axisMax;
     int nTicks;
 
-    range = max - min;
-
-    /* Calculate the major tick stepping. */
-    if (axisPtr->reqStep > 0.0) {
-	/* An interval was designated by the user.  Keep scaling it
-	 * until it fits comfortably within the current range of the
-	 * axis.  */
-	step = axisPtr->reqStep;
-	while ((2 * step) >= range) {
-	    step *= 0.5;
+    nTicks = 0;
+    tickMin = tickMax = 0.0;
+    if (min < max) {
+	range = max - min;
+	
+	/* Calculate the major tick stepping. */
+	if (axisPtr->reqStep > 0.0) {
+	    /* An interval was designated by the user.  Keep scaling it
+	     * until it fits comfortably within the current range of the
+	     * axis.  */
+	    step = axisPtr->reqStep;
+	    while ((2 * step) >= range) {
+		step *= 0.5;
+	    }
+	} else {
+	    range = NiceNum(range, 0);
+	    step = NiceNum(range / DEF_NUM_TICKS, 1);
 	}
-    } else {
-	range = NiceNum(range, 0);
-	step = NiceNum(range / DEF_NUM_TICKS, 1);
+	
+	/* Find the outer tick values. Add 0.0 to prevent getting -0.0. */
+	axisMin = tickMin = floor(min / step) * step + 0.0;
+	axisMax = tickMax = ceil(max / step) * step + 0.0;
+	
+	nTicks = Round((tickMax - tickMin) / step) + 1;
     }
-
-    /* Find the outer tick values. Add 0.0 to prevent getting -0.0. */
-    axisMin = tickMin = floor(min / step) * step + 0.0;
-    axisMax = tickMax = ceil(max / step) * step + 0.0;
-
-    nTicks = Round((tickMax - tickMin) / step) + 1;
     axisPtr->majorSweep.step = step;
     axisPtr->majorSweep.initial = tickMin;
     axisPtr->majorSweep.nSteps = nTicks;
-
+    
     /*
      * The limits of the axis are either the range of the data
      * ("tight") or at the next outer tick interval ("loose").  The
@@ -1596,9 +1603,9 @@
 	axisMax = max;
     }
     SetAxisRange(&axisPtr->axisRange, axisMin, axisMax);
-
+    
     /* Now calculate the minor tick step and number. */
-
+    
     if ((axisPtr->reqNumMinorTicks > 0) && 
 	((axisPtr->flags & AXIS_CONFIG_MAJOR) == 0)) {
 	nTicks = axisPtr->reqNumMinorTicks - 1;
@@ -1614,7 +1621,6 @@
     axisPtr->minorSweep.nSteps = nTicks;
 }
 
-
 static void
 SweepTicks(axisPtr)
     Axis *axisPtr;
@@ -1684,9 +1690,11 @@
     for (linkPtr = Blt_ChainFirstLink(graphPtr->elements.displayList);
 	linkPtr != NULL; linkPtr = Blt_ChainNextLink(linkPtr)) {
 	elemPtr = Blt_ChainGetValue(linkPtr);
-	(*elemPtr->procsPtr->extentsProc) (elemPtr, &exts);
-	GetDataLimits(elemPtr->axes.x, exts.left, exts.right);
-	GetDataLimits(elemPtr->axes.y, exts.top, exts.bottom);
+	if (!elemPtr->hidden) {
+	    (*elemPtr->procsPtr->extentsProc) (elemPtr, &exts);
+	    GetDataLimits(elemPtr->axes.x, exts.left, exts.right);
+	    GetDataLimits(elemPtr->axes.y, exts.top, exts.bottom);
+	}
     }
     /*
      * Step 3:  Now that we know the range of data values for each axis,
@@ -3417,7 +3425,7 @@
 	return Tk_ConfigureInfo(graphPtr->interp, graphPtr->tkwin, configSpecs,
 	    (char *)axisPtr, argv[0], flags);
     }
-    if (Tk_ConfigureWidget(graphPtr->interp, graphPtr->tkwin, configSpecs,
+    if (Blt_ConfigureWidget(graphPtr->interp, graphPtr->tkwin, configSpecs,
 	    argc, argv, (char *)axisPtr, flags) != TCL_OK) {
 	return TCL_ERROR;
     }
@@ -3639,7 +3647,7 @@
     Blt_Uid classUid;
     int margin;
 
-    margin = (int)argv[-1];
+    margin = (int)(uintptr_t)argv[-1];
     chainPtr = graphPtr->margins[margin].axes;
     if (argc == 0) {
 	for (linkPtr = Blt_ChainFirstLink(chainPtr); linkPtr!= NULL;
@@ -4182,7 +4190,7 @@
     if (proc == NULL) {
 	return TCL_ERROR;
     }
-    argv[2] = (char *)margin; /* Hack. Slide a reference to the margin in 
+    argv[2] = (char *)(uintptr_t)margin; /* Hack. Slide a reference to the margin in 
 			       * the argument list. Needed only for UseOp.
 			       */
     axisPtr = Blt_GetFirstAxis(graphPtr->margins[margin].axes);
diff -uNr blt2.4z.orig/src/bltGrBar.c blt2.4z/src/bltGrBar.c
--- blt2.4z.orig/src/bltGrBar.c	2002-09-18 18:30:51.000000000 -0400
+++ blt2.4z/src/bltGrBar.c	2013-07-15 11:15:51.000000000 -0400
@@ -2197,13 +2197,13 @@
 	    if (isNew) {
 		count = 1;
 	    } else {
-		count = (int)Blt_GetHashValue(hPtr);
+		count = (int)(uintptr_t)Blt_GetHashValue(hPtr);
 		if (count == 1) {
 		    nStacks++;
 		}
 		count++;
 	    }
-	    Blt_SetHashValue(hPtr, (ClientData)count);
+	    Blt_SetHashValue(hPtr, (ClientData)(uintptr_t)count);
 	}
     }
     if (nSegs == 0) {
@@ -2219,12 +2219,12 @@
 	infoPtr = graphPtr->freqArr;
 	for (hPtr = Blt_FirstHashEntry(&freqTable, &cursor); hPtr != NULL;
 	    hPtr = Blt_NextHashEntry(&cursor)) {
-	    count = (int)Blt_GetHashValue(hPtr);
+	    count = (int)(uintptr_t)Blt_GetHashValue(hPtr);
 	    keyPtr = (FreqKey *)Blt_GetHashKey(&freqTable, hPtr);
 	    if (count > 1) {
 		h2Ptr = Blt_CreateHashEntry(&(graphPtr->freqTable),
 		    (char *)keyPtr, &isNew);
-		count = (int)Blt_GetHashValue(hPtr);
+		count = (int)(uintptr_t)Blt_GetHashValue(hPtr);
 		infoPtr->freq = count;
 		infoPtr->axes = keyPtr->axes;
 		Blt_SetHashValue(h2Ptr, infoPtr);
diff -uNr blt2.4z.orig/src/bltGrElem.c blt2.4z/src/bltGrElem.c
--- blt2.4z.orig/src/bltGrElem.c	2002-09-18 18:30:51.000000000 -0400
+++ blt2.4z/src/bltGrElem.c	2013-07-15 11:15:51.000000000 -0400
@@ -1215,9 +1215,7 @@
 {
     int nNames;			/* Number of names found in Tcl name list */
     char **nameArr;		/* Broken out array of element names */
-    Blt_HashSearch cursor;
     register int i;
-    register Blt_HashEntry *hPtr;
     Element *elemPtr;		/* Element information record */
 
     if (Tcl_SplitList(graphPtr->interp, newList, &nNames, &nameArr) != TCL_OK) {
@@ -1227,17 +1225,11 @@
     }
     /* Clear the display list and mark all elements as hidden.  */
     Blt_ChainReset(graphPtr->elements.displayList);
-    for (hPtr = Blt_FirstHashEntry(&graphPtr->elements.table, &cursor);
-	hPtr != NULL; hPtr = Blt_NextHashEntry(&cursor)) {
-	elemPtr = (Element *)Blt_GetHashValue(hPtr);
-	elemPtr->hidden = TRUE;
-    }
 
     /* Rebuild the display list, checking that each name it exists
      * (currently ignoring invalid element names).  */
     for (i = 0; i < nNames; i++) {
 	if (NameToElement(graphPtr, nameArr[i], &elemPtr) == TCL_OK) {
-	    elemPtr->hidden = FALSE;
 	    Blt_ChainAppend(graphPtr->elements.displayList, elemPtr);
 	}
     }
@@ -1399,8 +1391,7 @@
 	    /* Comment the PostScript to indicate the start of the element */
 	    Blt_FormatToPostScript(psToken, "\n%% Element \"%s\"\n\n", 
 		elemPtr->name);
-	    (*elemPtr->procsPtr->printNormalProc) (graphPtr, psToken, 
-		elemPtr);
+	    (*elemPtr->procsPtr->printNormalProc) (graphPtr, psToken, elemPtr);
 	}
     }
 }
@@ -1426,8 +1417,7 @@
 	if ((!elemPtr->hidden) && (elemPtr->flags & ELEM_ACTIVE)) {
 	    Blt_FormatToPostScript(psToken, "\n%% Active Element \"%s\"\n\n",
 		elemPtr->name);
-	    (*elemPtr->procsPtr->printActiveProc) (graphPtr, psToken, 
-						   elemPtr);
+	    (*elemPtr->procsPtr->printActiveProc) (graphPtr, psToken, elemPtr);
 	}
     }
 }
@@ -1671,6 +1661,7 @@
     ClosestSearch search;
     int i, x, y;
     int flags = TCL_LEAVE_ERR_MSG;
+    int found;
 
     if (graphPtr->flags & RESET_AXES) {
 	Blt_ResetAxes(graphPtr);
@@ -1705,7 +1696,7 @@
     search.x = x;
     search.y = y;
 
-    if (Tk_ConfigureWidget(interp, graphPtr->tkwin, closestSpecs, i - 6,
+    if (Blt_ConfigureWidget(interp, graphPtr->tkwin, closestSpecs, i - 6,
 	    argv + 6, (char *)&search, TK_CONFIG_ARGV_ONLY) != TCL_OK) {
 	return TCL_ERROR;	/* Error occurred processing an option. */
     }
@@ -1715,13 +1706,23 @@
     search.dist = (double)(search.halo + 1);
 
     if (i < argc) {
+	Blt_ChainLink *linkPtr;
+
 	for ( /* empty */ ; i < argc; i++) {
 	    if (NameToElement(graphPtr, argv[i], &elemPtr) != TCL_OK) {
 		return TCL_ERROR;	/* Can't find named element */
 	    }
-	    if (elemPtr->hidden) {
+	    found = FALSE;
+	    for (linkPtr = Blt_ChainFirstLink(graphPtr->elements.displayList);
+		 linkPtr == NULL; linkPtr = Blt_ChainNextLink(linkPtr)) {
+		if (elemPtr == Blt_ChainGetValue(linkPtr)) {
+		    found = TRUE;
+		    break;
+		}
+	    }
+	    if ((!found) || (elemPtr->hidden)) {
 		Tcl_AppendResult(interp, "element \"", argv[i], "\" is hidden",
-		    (char *)NULL);
+			(char *)NULL);
 		return TCL_ERROR;	/* Element isn't visible */
 	    }
 	    /* Check if the X or Y vectors have notifications pending */
@@ -1744,16 +1745,14 @@
 	for (linkPtr = Blt_ChainLastLink(graphPtr->elements.displayList);
 	    linkPtr != NULL; linkPtr = Blt_ChainPrevLink(linkPtr)) {
 	    elemPtr = Blt_ChainGetValue(linkPtr);
-
 	    /* Check if the X or Y vectors have notifications pending */
-	    if ((elemPtr->flags & MAP_ITEM) ||
+	    if ((elemPtr->hidden) || 
+		(elemPtr->flags & MAP_ITEM) ||
 		(Blt_VectorNotifyPending(elemPtr->x.clientId)) ||
 		(Blt_VectorNotifyPending(elemPtr->y.clientId))) {
 		continue;
 	    }
-	    if (!elemPtr->hidden) {
-		(*elemPtr->procsPtr->closestProc) (graphPtr, elemPtr, &search);
-	    }
+	    (*elemPtr->procsPtr->closestProc)(graphPtr, elemPtr, &search);
 	}
 
     }
@@ -1851,7 +1850,7 @@
 	    return Tk_ConfigureInfo(interp, graphPtr->tkwin, 
 		elemPtr->specsPtr, (char *)elemPtr, options[0], flags);
 	}
-	if (Tk_ConfigureWidget(interp, graphPtr->tkwin, elemPtr->specsPtr, 
+	if (Blt_ConfigureWidget(interp, graphPtr->tkwin, elemPtr->specsPtr, 
 		numOpts, options, (char *)elemPtr, flags) != TCL_OK) {
 	    return TCL_ERROR;
 	}
@@ -1859,30 +1858,6 @@
 	    return TCL_ERROR;	/* Failed to configure element */
 	}
 	if (Blt_ConfigModified(elemPtr->specsPtr, "-hide", (char *)NULL)) {
-	    Blt_ChainLink *linkPtr;
-
-	    for (linkPtr = Blt_ChainFirstLink(graphPtr->elements.displayList);
-		linkPtr != NULL; linkPtr = Blt_ChainNextLink(linkPtr)) {
-		if (elemPtr == Blt_ChainGetValue(linkPtr)) {
-		    break;
-		}
-	    }
-	    if ((elemPtr->hidden) != (linkPtr == NULL)) {
-
-		/* The element's "hidden" variable is out of sync with
-		 * the display list. [That's what you get for having
-		 * two ways to do the same thing.]  This affects what
-		 * elements are considered for axis ranges and
-		 * displayed in the legend. Update the display list by
-		 * either by adding or removing the element.  */
-
-		if (linkPtr == NULL) {
-		    Blt_ChainPrepend(graphPtr->elements.displayList, elemPtr);
-		} else {
-		    Blt_ChainDeleteLink(graphPtr->elements.displayList, 
-					linkPtr);
-		}
-	    }
 	    graphPtr->flags |= RESET_AXES;
 	    elemPtr->flags |= MAP_ITEM;
 	}
diff -uNr blt2.4z.orig/src/bltGrGrid.c blt2.4z/src/bltGrGrid.c
--- blt2.4z.orig/src/bltGrGrid.c	2002-06-11 03:13:55.000000000 -0400
+++ blt2.4z/src/bltGrGrid.c	2013-07-15 11:15:51.000000000 -0400
@@ -365,7 +365,7 @@
 	return Tk_ConfigureInfo(interp, graphPtr->tkwin, configSpecs,
 	    (char *)gridPtr, argv[3], flags);
     }
-    if (Tk_ConfigureWidget(graphPtr->interp, graphPtr->tkwin, configSpecs,
+    if (Blt_ConfigureWidget(graphPtr->interp, graphPtr->tkwin, configSpecs,
 	    argc - 3, argv + 3, (char *)gridPtr, flags) != TCL_OK) {
 	return TCL_ERROR;
     }
diff -uNr blt2.4z.orig/src/bltGrHairs.c blt2.4z/src/bltGrHairs.c
--- blt2.4z.orig/src/bltGrHairs.c	2002-06-17 19:07:19.000000000 -0400
+++ blt2.4z/src/bltGrHairs.c	2013-07-15 11:15:51.000000000 -0400
@@ -390,7 +390,7 @@
 	return Tk_ConfigureInfo(interp, graphPtr->tkwin, configSpecs,
 		(char *)chPtr, argv[3], 0);
     }
-    if (Tk_ConfigureWidget(interp, graphPtr->tkwin, configSpecs, argc - 3,
+    if (Blt_ConfigureWidget(interp, graphPtr->tkwin, configSpecs, argc - 3,
 	    argv + 3, (char *)chPtr, TK_CONFIG_ARGV_ONLY) != TCL_OK) {
 	return TCL_ERROR;
     }
diff -uNr blt2.4z.orig/src/bltGrLegd.c blt2.4z/src/bltGrLegd.c
--- blt2.4z.orig/src/bltGrLegd.c	2002-09-18 18:30:51.000000000 -0400
+++ blt2.4z/src/bltGrLegd.c	2013-07-15 11:15:51.000000000 -0400
@@ -1406,7 +1406,7 @@
 	return Tk_ConfigureInfo(interp, graphPtr->tkwin, configSpecs,
 		(char *)legendPtr, argv[3], flags);
     }
-    if (Tk_ConfigureWidget(interp, graphPtr->tkwin, configSpecs, argc - 3,
+    if (Blt_ConfigureWidget(interp, graphPtr->tkwin, configSpecs, argc - 3,
 	    argv + 3, (char *)legendPtr, flags) != TCL_OK) {
 	return TCL_ERROR;
     }
diff -uNr blt2.4z.orig/src/bltGrLine.c blt2.4z/src/bltGrLine.c
--- blt2.4z.orig/src/bltGrLine.c	2002-10-14 19:31:24.000000000 -0400
+++ blt2.4z/src/bltGrLine.c	2013-07-15 11:15:51.000000000 -0400
@@ -1211,7 +1211,7 @@
 NameOfSmooth(value)
     Smoothing value;
 {
-    if ((value < 0) || (value >= PEN_SMOOTH_LAST)) {
+    if (value >= PEN_SMOOTH_LAST) {
 	return "unknown smooth value";
     }
     return smoothingInfo[value].name;
diff -uNr blt2.4z.orig/src/bltGrMarker.c blt2.4z/src/bltGrMarker.c
--- blt2.4z.orig/src/bltGrMarker.c	2002-09-18 18:30:51.000000000 -0400
+++ blt2.4z/src/bltGrMarker.c	2013-07-15 11:15:51.000000000 -0400
@@ -29,6 +29,9 @@
 #include "bltChain.h"
 #include "bltGrElem.h"
 
+#define GETBITMAP(b) \
+	(((b)->destBitmap == None) ? (b)->srcBitmap : (b)->destBitmap)
+
 #define MAX_OUTLINE_POINTS	12
 
 /* Map graph coordinates to normalized coordinates [0..1] */
@@ -812,7 +815,13 @@
 
     /* Polygon specific attributes and fields */
 
-    Point2D *screenPts;
+    Point2D *screenPts;		/* Array of points representing the
+				 * polygon in screen coordinates. It's
+				 * not used for drawing, but to
+				 * generate the outlinePts and fillPts
+				 * arrays that are the coordinates of
+				 * the possibly clipped outline and
+				 * filled polygon. */
 
     ColorPair outline;
     ColorPair fill;
@@ -1061,10 +1070,12 @@
     Graph *graphPtr;
     Extents2D *extsPtr;
 {
+/*
     assert(extsPtr->right >= extsPtr->left);
     assert(extsPtr->bottom >= extsPtr->top);
     assert(graphPtr->right >= graphPtr->left);
     assert(graphPtr->bottom >= graphPtr->top);
+*/
 
     return (((double)graphPtr->right < extsPtr->left) ||
 	    ((double)graphPtr->bottom < extsPtr->top) ||
@@ -1563,9 +1574,6 @@
     if (bmPtr->srcBitmap == None) {
 	return TCL_OK;
     }
-    if (bmPtr->destBitmap == None) {
-	bmPtr->destBitmap = bmPtr->srcBitmap;
-    }
     bmPtr->theta = FMOD(bmPtr->rotate, 360.0);
     if (bmPtr->theta < 0.0) {
 	bmPtr->theta += 360.0;
@@ -1650,9 +1658,9 @@
     if (bmPtr->srcBitmap == None) {
 	return;
     }
-    if (bmPtr->destBitmap != bmPtr->srcBitmap) {
+    if (bmPtr->destBitmap != None) {
 	Tk_FreePixmap(graphPtr->display, bmPtr->destBitmap);
-	bmPtr->destBitmap = bmPtr->srcBitmap;
+	bmPtr->destBitmap = None;
     }
     /* 
      * Collect the coordinates.  The number of coordinates will determine
@@ -1752,7 +1760,7 @@
     } else {
 	bmPtr->destWidth = srcWidth;
 	bmPtr->destHeight = srcHeight;
-	bmPtr->destBitmap = bmPtr->srcBitmap;
+	bmPtr->destBitmap = None;
     }
     bmPtr->anchorPos = anchorPos;
     {
@@ -1909,9 +1917,10 @@
     Graph *graphPtr = markerPtr->graphPtr;
     BitmapMarker *bmPtr = (BitmapMarker *)markerPtr;
     double theta;
+    Pixmap bitmap;
 
-    if ((bmPtr->destBitmap == None) || (bmPtr->destWidth < 1) || 
-	(bmPtr->destHeight < 1)) {
+    bitmap = GETBITMAP(bmPtr);
+    if ((bitmap == None) || (bmPtr->destWidth < 1) || (bmPtr->destHeight < 1)) {
 	return;
     }
     theta = FMOD(bmPtr->theta, (double)90.0);
@@ -1934,14 +1943,14 @@
 	    XFillPolygon(graphPtr->display, drawable, bmPtr->fillGC,
 		 polygon, bmPtr->nOutlinePts, Convex, CoordModeOrigin);
 	}
-	XSetClipMask(graphPtr->display, bmPtr->gc, bmPtr->destBitmap);
+	XSetClipMask(graphPtr->display, bmPtr->gc, bitmap);
 	XSetClipOrigin(graphPtr->display, bmPtr->gc, (int)bmPtr->anchorPos.x, 
 	       (int)bmPtr->anchorPos.y);
     } else {
 	XSetClipMask(graphPtr->display, bmPtr->gc, None);
 	XSetClipOrigin(graphPtr->display, bmPtr->gc, 0, 0);
     }
-    XCopyPlane(graphPtr->display, bmPtr->destBitmap, drawable, bmPtr->gc, 0, 0,
+    XCopyPlane(graphPtr->display, bitmap, drawable, bmPtr->gc, 0, 0,
 	bmPtr->destWidth, bmPtr->destHeight, (int)bmPtr->anchorPos.x, 
 	(int)bmPtr->anchorPos.y, 1);
 }
@@ -1965,8 +1974,10 @@
 {
     Graph *graphPtr = markerPtr->graphPtr;
     BitmapMarker *bmPtr = (BitmapMarker *)markerPtr;
+    Pixmap bitmap;
 
-    if (bmPtr->destBitmap == None) {
+    bitmap = GETBITMAP(bmPtr);
+    if (bitmap == None) {
 	return;
     }
     if (bmPtr->fillColor != NULL) {
@@ -1982,7 +1993,7 @@
     Blt_FormatToPostScript(psToken, "    %d %d true [%d 0 0 %d 0 %d] {",
 	bmPtr->destWidth, bmPtr->destHeight, bmPtr->destWidth, 
 	-bmPtr->destHeight, bmPtr->destHeight);
-    Blt_BitmapDataToPostScript(psToken, graphPtr->display, bmPtr->destBitmap,
+    Blt_BitmapDataToPostScript(psToken, graphPtr->display, bitmap,
 	bmPtr->destWidth, bmPtr->destHeight);
     Blt_AppendToPostScript(psToken, "    } imagemask\n",
 	"grestore\n", (char *)NULL);
@@ -2018,7 +2029,7 @@
     if (bmPtr->fillGC != NULL) {
 	Tk_FreeGC(graphPtr->display, bmPtr->fillGC);
     }
-    if (bmPtr->destBitmap != bmPtr->srcBitmap) {
+    if (bmPtr->destBitmap != None) {
 	Tk_FreePixmap(graphPtr->display, bmPtr->destBitmap);
     }
 }
@@ -2127,8 +2138,6 @@
 	    imPtr->tkImage = Tk_GetImage(interp, graphPtr->tkwin,
 		imPtr->imageName, ImageChangedProc, imPtr);
 	    if (imPtr->tkImage == NULL) {
-		Tcl_AppendResult(interp, "can't find an image \"", 
-			imPtr->imageName, "\"", (char *)NULL);
 		Blt_Free(imPtr->imageName);
 		imPtr->imageName = NULL;
 		return TCL_ERROR;
@@ -2494,6 +2503,9 @@
     if (imPtr->srcImage != NULL) {
 	Blt_FreeColorImage(imPtr->srcImage);
     }
+    if (imPtr->gc != NULL) {
+	Tk_FreeGC(graphPtr->display, imPtr->gc);
+    }
 }
 
 /*
@@ -3747,11 +3759,11 @@
 {
     PolygonMarker *pmPtr = (PolygonMarker *)markerPtr;
 
-    if (pmPtr->nWorldPts < 2) {
-	return FALSE;
+    if ((pmPtr->nWorldPts >= 3) && (pmPtr->screenPts != NULL)) {
+	return Blt_PointInPolygon(samplePtr, pmPtr->screenPts, 
+		  pmPtr->nWorldPts + 1);
     }
-    return Blt_PointInPolygon(samplePtr, pmPtr->screenPts, 
-	pmPtr->nWorldPts + 1);
+    return FALSE;
 }
 
 /*
@@ -3769,7 +3781,7 @@
 {
     PolygonMarker *pmPtr = (PolygonMarker *)markerPtr;
     
-    if (pmPtr->nWorldPts >= 3) {
+    if ((pmPtr->nWorldPts >= 3) && (pmPtr->screenPts != NULL)) {
 	return Blt_RegionInPolygon(extsPtr, pmPtr->screenPts, pmPtr->nWorldPts,
 	       enclosed);
     }
@@ -4036,6 +4048,9 @@
     if (pmPtr->outlinePts != NULL) {
 	Blt_Free(pmPtr->outlinePts);
     }
+    if (pmPtr->screenPts != NULL) {
+	Blt_Free(pmPtr->screenPts);
+    }
     Blt_FreeColorPair(&pmPtr->outline);
     Blt_FreeColorPair(&pmPtr->fill);
 }
@@ -4260,6 +4275,7 @@
     int nNames, nOpts;
     char **options;
     register int i;
+    int under;
 
     /* Figure out where the option value pairs begin */
     argc -= 3;
@@ -4289,7 +4305,8 @@
 	}
 	/* Save the old marker. */
 	oldName = markerPtr->name;
-	if (Tk_ConfigureWidget(interp, graphPtr->tkwin, 
+	under = markerPtr->drawUnder;
+	if (Blt_ConfigureWidget(interp, graphPtr->tkwin, 
 		markerPtr->classPtr->configSpecs, nOpts, options, 
 		(char *)markerPtr, flags) != TCL_OK) {
 	    return TCL_ERROR;
@@ -4304,6 +4321,9 @@
 	if ((*markerPtr->classPtr->configProc) (markerPtr) != TCL_OK) {
 	    return TCL_ERROR;
 	}
+	if (markerPtr->drawUnder != under) {
+	    graphPtr->flags |= REDRAW_BACKING_STORE;
+	}
     }
     return TCL_OK;
 }
@@ -4942,7 +4962,14 @@
     for (linkPtr = Blt_ChainLastLink(graphPtr->markers.displayList);
 	linkPtr != NULL; linkPtr = Blt_ChainPrevLink(linkPtr)) {
 	markerPtr = Blt_ChainGetValue(linkPtr);
+	/* 
+	 * Don't consider markers that are pending to be mapped. Even
+	 * if the marker has already been mapped, the coordinates
+	 * could be invalid now.  Better to pick no marker than the
+	 * wrong marker.
+	 */
 	if ((markerPtr->drawUnder == under) && (markerPtr->nWorldPts > 0) && 
+	    ((markerPtr->flags & MAP_ITEM) == 0) && 
 	    (!markerPtr->hidden) && (markerPtr->state == STATE_NORMAL)) {
 	    if ((*markerPtr->classPtr->pointProc) (markerPtr, &point)) {
 		return markerPtr;
